/* acm-s: a simple processor simulator
   Copyright (C) 2003 Angelo "Encelo" Theodorou
*/

#include "acm-s.h"
#include "dump.h"
#include "funcs.h"


extern unsigned char mem[];
extern char mnemonic[];

/* Visualizza il contenuto della memoria entro start_addr ed end_addr. Ritorna sempre 0*/
int dump(unsigned short int start_addr, unsigned short int end_addr)
{
	unsigned short int i = start_addr;
	unsigned short int word, nword; /* Vengono ricostruite le parole a 16 bit a partire dall'array di char di mem[] */
	
	while(i <= end_addr) {
		word = make_word(mem[i], mem[i+1]);
		disasm(word);
		if(need_operand(word)) {
			nword = make_word(mem[i+2], mem[i+3]);
			printf("0x%.4hx: 0x%.4hx 0x%.4hx  |  ", i, word, nword); /* Stampa anche l'operando */
			printf("%s 0x%.4hx\n", mnemonic, nword);
			i += 4;
		}
		else {
			printf("0x%.4hx: 0x%.4hx         |  ", i, word);
			printf("%s\n", mnemonic);
			i += 2;
		}
	}
	printf("\n");
	return 0;
}
