/* acm-s: a simple processor simulator
   Copyright (C) 2003 Angelo "Encelo" Theodorou
*/


#include "acm-s.h"
#include "load.h"
#include "funcs.h"


extern char mem[];

/* Carica il file di nome filename
   Codici di ritorno:
    0 : Nessun errore
   -1 : Errore nell'apertura del file
   -2 : Fuori dal range della memoria
*/
int loadfile(char *filename)
{
	FILE *fp;
	char hex[11]; /* Carattere esadecimale */
	unsigned short int word, nword;  /* Vengono ricostruite le parole a 16 bit a partire dall'array di char di mem[] */
	unsigned short int addr = 0x0000;
	
	if((fp = fopen(filename, "r")) == NULL)
		return -1; /* Errore nell'apertura del file */
	wipe_mem(); /* Reset della memoria */
	reset(); /* Reset dello stato del processore */
	while((fgets(hex, 11, fp)) != NULL) {
		sscanf(hex, "%hx", &word);
		if (need_operand(word)) {
			sscanf(hex, "%hx %hx", &word, &nword);
			mem[addr] = get_hi_byte(word);
			mem[addr+1] = get_low_byte(word);
			mem[addr+2] = get_hi_byte(nword);
			mem[addr+3] = get_low_byte(nword);
			addr += 4;
		}
		else {
			sscanf(hex, "%hx", &word);
			mem[addr] = get_hi_byte(word);
			mem[addr+1] = get_low_byte(word);
			addr += 2;
		}
		if(addr > MAXMEM)
			return -2; /* Fuori range */
	}
	fclose(fp);
	return 0;
}
