/* acm-s: a simple processor simulator
   Copyright (C) 2003 Angelo "Encelo" Theodorou
*/

#include "acm-s.h"
#include "load.h"
#include "dump.h"
#include "run.h"


unsigned char mem[MAXMEM];            /* Rappresenta la RAM dell'ACM-S */

/* Funzione principale. Ritorna 0 se tutto ha funzionato */
main()
{
	int menu, err;
	char filename[MAXLINE];
	unsigned int start_addr, end_addr;

	for(;;) {
		printf("\n");
		printf("\t\tACM-Simplified Simulator\n\n");
		printf("\t\t1. LOAD filename\n");
		printf("\t\t2. DUMP addr1 addr2\n");
		printf("\t\t3. RUN\n");
		printf("\t\t4. TRACE\n");
		printf("\t\t5. RESET\n");
		printf("\t\t6. EXIT\n\n\t\t");
		scanf("%d", &menu);
		printf("\n");

		switch(menu) {
			case 1:
				printf("File name to load?: ");
				scanf("%s", filename);
				printf("\n");
				if((err = loadfile(filename)) != 0){
					switch (err){
						case -1:
							printf("Error opening %s!\n", filename);
							break;
						case -2:
							printf("Out of memory range!\n");
							break;
					}
				}
				break;
			case 2:
				printf("\nSpecify starting and end address, separated with a space");
				scanf("%x %x", &start_addr, &end_addr);
				printf("\n");
				if(start_addr > end_addr)
					printf("End address must be greater than the starting one!\n");
				else if(start_addr >= 0 && end_addr < MAXMEM)
					dump(start_addr, end_addr);
				else
					printf("Addresses out of memory range!\n");
				break;
			case 3:
				run(NO_TRACE);
				break;
			case 4:
				run(TRACE);
				break;
			case 5:
				reset();
				break;
			case 6:
				exit(0);
				break;
			default:
				printf("Unknown option!\n");
				break;
		}
	}
	return 0;
}

